<?php


namespace app\admin\controller;


use app\admin\model\ActionList;
use think\App;
use think\facade\Validate;
class Action extends Base{

   public function __construct(App $app) {
       parent::__construct($app);
       $this->model = new ActionList();
   }

   public function create(){
       $post = $this->request->param(['action_name'=>'','action_code'=>'']);
        $valid = Validate::rule([
        	'action_name|功能名称'=>'require',
            'action_code|功能编号'=>'require|unique:action_list,action_code^is_del']);
        if($valid->check($post)==false)return error($valid->getError());
        $save=$this->model->save($post);
        if($save==false)return error('创建失败');
        return success('创建成功');
   }

   public function delete(){
       $post = $this->request->param(['id'=>0]);
       $valid = Validate::rule([
           'id|id'=>'require']);
       if($valid->check($post)==false)return error($valid->getError());
       $isUse=\app\admin\model\Action::where('action_id',$post['id'])->where('is_del',0)->count();
       if($isUse>0)return error('该功能已被使用，不能删除');
       $save=$this->model->where('id',$post['id'])->update(['is_del'=>1]);
       if($save==false)return error('删除失败');
       return success('删除成功');
   }
}