<?php
declare (strict_types = 1);

namespace app\admin\listener;

use app\admin\model\GoodBasic;
use app\admin\model\WarehouseInfo;
use think\facade\Validate;
class updateSupplierGood
{
    /**
     * 事件监听处理
     *
     * @return mixed
     */
    public function handle($event)
    {
        $supplierCode=$event["code"];
        $valide=Validate::rule([
            "code"=>"require|max:255",
            "personid"=>"require|number",
            "person"=>"require|max:255",
        ]);
        if(!$valide->check($event)){
           return $valide->getError();
        }
        $update= GoodBasic::where([['supplierNo','=',$supplierCode],['is_del','=',0]])->save(["chargerid" => $event['personid'], "charger" => $event['person']]);
        $ware =WarehouseInfo::where([['supplierNo','=',$supplierCode],['is_del','=',0],['wsm_type','=',2]])->save([['contactor' => $event['personid'], 'contactor_name' => $event['person']]]);
    }
}
