<?php
namespace app\admin\model;

class Filing extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'bigint',//
        'filingCode'       =>'varchar',//报备单编码
        'supplierNo'       =>'varchar',//供应商编号
        'supplierName'       =>'varchar',//供应商名称
        'companyCode'       =>'varchar',//客户编码
        'companyName'       =>'varchar',//客户名称
        'customerCode'       =>'varchar',//业务公司编码
        'customerName'       =>'varchar',//业务公司名称
        'num'       =>'int',//销售数量
        'transfer_num'       =>'int',//已转单数量
        'wait_num'       =>'int',//待转单数量
        'is_determine_price'       =>'tinyint',//是否确定售价,0否,1是
        'price'       =>'decimal',//销售价(不确定售价时，不必填)
        'expect_service_proportion'       =>'float',//期望服务费比例
        'service_proportion'       =>'decimal',//服务费比例
        'expect_service'       =>'decimal',//期望服务费
        'service_charge'       =>'decimal',//服务费
        'cgd_charge'       =>'decimal',//采购价(裸价)
        'brand_id'       =>'int',//品牌id
        'preservation_day'       =>'int',//有效期(天数)
        'delivery_day'       =>'int',//物流时间(天数)
        'make_day'       =>'int',//生产工期
        'tax'       =>'tinyint',//税点
        'unit_id'       =>'int',//单位id
        'cat_id'       =>'int',//分类id
        'spuCode'       =>'varchar',//商品编号
        'good_name'       =>'varchar',//商品名称
        'specinfo'       =>'text',//规格信息
        'origin_place'       =>'varchar',//产地
        'delivery_place'       =>'varchar',//发货地
        'weight'       =>'decimal',//总重量
        'supply_area'       =>'tinyint',//供货区域:1全国,2全国除偏远
        'pay_way'       =>'tinyint',//付款方式,0现结,1月清,2双月清
        'send_way'       =>'tinyint',//发货方式1自提2包邮
        'cert_fee'       =>'decimal',//证书费
        'pakge_fee'       =>'decimal',//包装费
        'cost_fee'       =>'decimal',//工艺费
        'mark_fee'       =>'decimal',//加标费
        'demo_fee'       =>'decimal',//打样费
        'open_fee'       =>'decimal',//开模费
        'delivery_fee'       =>'decimal',//物流费
        'gold_weight'       =>'decimal',//贵金属重量
        'noble_metal'       =>'tinyint',//贵金属类型:1.18K,2.24K,3.白银
        'is_gold_price'       =>'tinyint',//是否启用金价
        'is_diff'       =>'tinyint',//是否有工差
        'config'       =>'varchar',//配置要求
        'other_config'       =>'varchar',//其他配置要求
        'remark'       =>'varchar',//采购备注
        'cost_desc'       =>'varchar',//工艺说明
        'good_img'       =>'text',//商品图片
        'platform_id'       =>'int',//平台id
        'apply_id'       =>'bigint',//申请人id
        'apply_name'       =>'varchar',//申请人名称
        'manager'       =>'varchar',//项目经理
        'managerid'       =>'int',//
        'is_check'       =>'tinyint',//0 待判断 1 合规 2不合规
        'status'       =>'tinyint',//状态:0待审核,1审核失败,2审核中可转单(该状态下可多次审核),3转单成功,4转单失败,5取消转单
        'is_del'       =>'tinyint',//是否删除:0未删除,1删除
        'addtime'       =>'datetime',//创建时间
        'updaterid'       =>'int',//更新人id
        'updater'       =>'varchar',//更新人
        'updatetime'       =>'datetime',//更新时间
        'reason'       =>'varchar',//转单失败原因
        'plat_orderCode'       =>'varchar',//
        'plat_code'       =>'varchar',//平台商品编码
        'orderCode'       =>'varchar',//订单编码
        'fill_url'       =>'varchar',//附件

    ];
}