<?php
namespace app\admin\model;

class GoodBasic extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'bigint',//
        'spuCode'       =>'varchar',//商品spuCode
        'good_code'       =>'varchar',//商品code
        'good_name'       =>'varchar',//商品名称
        'cat_id'       =>'bigint',//分类id
        'brand_id'       =>'bigint',//商品品牌id
        'companyNo'       =>'varchar',//业务公司id
        'companyName'       =>'varchar',//业务公司名称
        'good_unit'       =>'varchar',//商品单位
        'good_type'       =>'tinyint',//商品类型 1 定制2常规
        'moq'       =>'int',//起订量
        'is_exclusive'       =>'tinyint',//0非专属1泰康
        'customized'       =>'int',//定制工期
        'tax'       =>'varchar',//税点
        'supplierNo'       =>'varchar',//供应商code
        'supplierName'       =>'varchar',//供应商名称
        'is_auth'       =>'tinyint',//是否有销售权限
        'auth_img'       =>'varchar',//销售授权图片
        'is_stock'       =>'tinyint',//是否库存品
        'after_sales'       =>'text',//售后说明
        'craft_desc'       =>'text',//工艺说明
        'good_remark'       =>'varchar',//商品备注
        'good_size'       =>'varchar',//商品尺寸
        'weight'       =>'decimal',//商品重量
        'packing_way'       =>'varchar',//包装方式
        'packing_size'       =>'varchar',//装箱尺寸
        'packing_spec'       =>'varchar',//装箱规格
        'packing_list'       =>'varchar',//包装清单
        'packing_weight'       =>'decimal',//装箱重量
        'good_bar'       =>'varchar',//商品条形码
        'supply_area'       =>'varchar',//供货区域:1全国,2全国除偏远
        'delivery_place'       =>'varchar',//发货地
        'origin_place'       =>'varchar',//产地
        'delivery_day'       =>'int',//物流时间
        'lead_time'       =>'int',//供货周期
        'sample_day'       =>'int',//调样周期
        'sample_fee'       =>'decimal',//调样费有
        'good_img'       =>'text',//商品详情主图 
        'good_thumb_img'       =>'varchar',//商品缩略图
        'good_info_img'       =>'text',//商品详情图
        'cert_fee'       =>'decimal',//证书费
        'packing_fee'       =>'decimal',//包装费
        'cost_fee'       =>'decimal',//工艺费
        'mark_fee'       =>'decimal',//加标费
        'demo_fee'       =>'decimal',//打样费
        'open_fee'       =>'decimal',//开模费
        'noble_metal'       =>'tinyint',//贵金属种类1 18k 2 24k 3白银 
        'noble_weight'       =>'decimal',//贵金属种量
        'is_gold_price'       =>'tinyint',//是否使用实时金价
        'cgd_gold_price'       =>'decimal',//供应商采购金价
        'market_price'       =>'decimal',//市场价
        'nake_price'       =>'decimal',//含税成本价
        'is_step'       =>'tinyint',//阶梯价是否启用
        'is_online'       =>'tinyint',//是否上线
        'status'       =>'tinyint',//审核状态:0新建待审核,1审核通过,2基础修改待审核,3成本修改待审核,4基础修改驳回,5成本修改驳回,6新建审核驳回,7复制商品待编辑,8咨询商品待编辑
        'createrid'       =>'int',//创建人id
        'creater'       =>'varchar',//创建人
        'create_source'       =>'tinyint',//创建来源 0 手动创建1 咨询
        'field_change'       =>'text',//
        'is_del'       =>'tinyint',//是否删除
        'addtime'       =>'datetime',//
        'updatetime'       =>'datetime',//
        'is_diff'       =>'tinyint',//是否有工差
        'config'       =>'varchar',//配置
        'other_config'       =>'varchar',//其他配置
        'stock_moq'       =>'int',//库存备库起订数量
        'is_support_barter'       =>'tinyint',//是否可退货,1可以,0不可以
        'chargerid'       =>'int',//负责人id
        'charger'       =>'varchar',//负责人(采销的话跟创建人一致，供应商端口取供应商的负责人)
        'is_support_stock'       =>'tinyint',//是支持非库存转换 0 不支持1支持
        'is_combind'       =>'tinyint',//是否组合商品
        'supplier_origin_price'       =>'decimal',//供应商采购成本
        'cgd_supplier_code'       =>'varchar',//采购供应商编号
        'cgd_supplier_name'       =>'varchar',//采购供应商名称
        'cgd_apply_id'       =>'int',//竞单人
        'cgd_apply_name'       =>'varchar',//竞单人
        'isChild'       =>'tinyint',//是否子商品
    ];
    public function Unit(){
        return $this->hasOne('Unit','good_unit','id')->bind(["unit_name"]);
    }
    public function Cat(){
        return $this->hasOne('Cat','cat_id','id')->bind(["cat_name"]);
    }

    public function Brand(){
        return $this->hasOne('Brand','brand_id','id')->bind(["brand_name"]);
    }

    public function GoodTax(){
        return $this->hasOne('GoodTax',"spuCode",'spuCode')
        ->bind([
            "in_tax"=>"tax",
            "in_tax_short_name",
            "in_tax_merge_code",
            "in_tax_cat_code",
            "in_tax_name",
            "inv_good_name",
            "out_tax",
            "out_tax_short_name",
            "out_tax_merge_code",
            "out_tax_name",
            "out_tax_cat_code",
            "cgd_tax",
            "cgd_tax_short_name",
            "cgd_tax_merge_code",
            "cgd_tax_name",
            "cgd_tax_cat_code",
            "addTax",
            "sumitem"
        ]);
    }
}