<?php
namespace app\admin\model;

class GoodZixun extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'bigint',//
        'spuCode'       =>'varchar',//商品spuCode
        'good_code'       =>'varchar',//商品code
        'good_name'       =>'varchar',//商品名称
        'brand_id'       =>'bigint',//商品品牌id
        'cat_id'       =>'int',//分类id
        'good_unit'       =>'varchar',//商品单位
        'good_type'       =>'tinyint',//商品类型 1 定制2常规
        'moq'       =>'int',//起订量
        'customized'       =>'int',//定制工期
        'tax'       =>'varchar',//税点
        'platform_id'       =>'int',//平台id
        'supplierNo'       =>'varchar',//供应商code
        'supplierName'       =>'varchar',//
        'is_auth'       =>'tinyint',//是否有销售权限
        'auth_img'       =>'varchar',//销售授权图片
        'craft_desc'       =>'text',//工艺说明
        'good_remark'       =>'varchar',//商品备注
        'good_img'       =>'text',//商品详情主图 
        'good_thumb_img'       =>'varchar',//商品缩略图
        'good_info_img'       =>'varchar',//商品详情图
        'status'       =>'tinyint',//状态,1默认，2添加到商品库
        'createrid'       =>'int',//创建人id
        'creater'       =>'varchar',//创建人
        'is_del'       =>'tinyint',//是否删除
        'addtime'       =>'datetime',//
        'updatetime'       =>'datetime',//
        'supplier_origin_price'       =>'decimal',//供应商采购成本
        'cgd_supplier_code'       =>'varchar',//采购供应商编号
        'cgd_supplier_name'       =>'varchar',//采购供应商名称
        'cgd_apply_id'       =>'int',//竞单人
        'cgd_apply_name'       =>'varchar',//竞单人
        'specinfo'       =>'text',//规格配置
        'work_day'       =>'int',//工期
        'noble_metal'       =>'tinyint',//贵金属材质 118k 2 24k 3 白银
        'is_gold_price'       =>'tinyint',//是否使用实时金价
        'good_weight'       =>'decimal',//
        'config'       =>'varchar',//配置要求
        'other_config'       =>'varchar',//其他配置
        'weight'       =>'double',//商品重量
        'supply_area'       =>'tinyint',//
        'is_diff'       =>'tinyint',//是否有工差
        'is_combind'       =>'tinyint',//是否组合商品
        'pay_way'       =>'tinyint',//付款方式
        'send_way'       =>'tinyint',//
        'companyNo'       =>'varchar',//业务公司编号
        'companyName'       =>'varchar',//
        'proof_type'       =>'tinyint',//凭证类型
        'proof_url'       =>'varchar',//凭证文件
        'usable_stock'       =>'bigint',//仓库可用库存
        'isChild'       =>'tinyint',//是否子商品
        'order_source'       =>'tinyint',//
        'order_type'       =>'tinyint',//商品类型
        'order_createrid'       =>'int',//订单创建人
        'order_creater'       =>'varchar',//订单创建人
    ];

    public function Brand(){
        return $this->hasOne('Brand','brand_id','id')->bind(["brand_name"]);
    }
    public function Cat(){
        return $this->hasOne('Cat','cat_id','id')->bind(["cat_name"]);
    }
    public function Unit(){
        return $this->hasOne('Unit','good_unit','id')->bind(["unit_name"]);
    }
    public function GoodTax(){
         return $this->hasOne('GoodTax','spuCode','spuCode')
        ->bind([
                "in_tax"=>"tax",
                "in_tax_short_name",
                "in_tax_merge_code",
                "in_tax_cat_code",
                "in_tax_name",
                "inv_good_name",
                "out_tax",
                "out_tax_short_name",
                "out_tax_merge_code",
                "out_tax_name",
                "out_tax_cat_code",
                "cgd_tax",
                "cgd_tax_short_name",
                "cgd_tax_merge_code",
                "cgd_tax_name",
                "cgd_tax_cat_code",
                "addTax",
                "sumitem"
                ]);
    }
}