<?php
namespace app\admin\model;

class PurcheaseOrder extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'bigint',//
        'cgdNo'       =>'varchar',//采购单号
        'bkcode'       =>'varchar',//备库申请单号
        'wsm_code'       =>'varchar',//仓库编号
        'cgder_id'       =>'bigint',//采购员id
        'cgder'       =>'varchar',//采购员名称
        'spuCode'       =>'varchar',//商品编号
        'good_name'       =>'varchar',//商品名称
        'skuCode'       =>'varchar',//商品type_code
        'good_num'       =>'int',//采购数量
        'good_price'       =>'decimal',//采购单价
        'total_fee'       =>'decimal',//采购总额
        'origin_total'       =>'decimal',//原采购额
        'pakge_fee'       =>'decimal',//包装费
        'cert_fee'       =>'decimal',//证书费
        'open_fee'       =>'decimal',//开模费
        'delivery_fee'       =>'decimal',//物流费
        'mark_fee'       =>'decimal',//加标费
        'teach_fee'       =>'decimal',//工艺费
        'nake_fee'       =>'decimal',//裸价费
        'demo_fee'       =>'decimal',//打样费
        'weight'       =>'decimal',//重量
        'diff_weight'       =>'decimal',//工差重量
        'diff_fee'       =>'decimal',//工差金额
        'gold_price'       =>'decimal',//实时金价
        'supplierNo'       =>'varchar',//供应商code
        'supplier_name'       =>'varchar',//供应商名称
        'companyNo'       =>'varchar',//业务企业编号
        'companyName'       =>'varchar',//业务公司名称
        'send_status'       =>'int',//发货状态:1未发,2部分发货,3全部发货
        'send_num'       =>'int',//发货数量
        'wsend_num'       =>'int',//未发货数量
        'remark'       =>'varchar',//备注
        'status'       =>'int',//状态,0待与供应商确认,1待入库,2部分入库,3入库完成,4已取消订单
        'lasttime'       =>'datetime',//最后入库时间
        'is_del'       =>'int',//
        'th_num'       =>'int',//退货数量
        'th_fee'       =>'decimal',//退货金额
        'order_type'       =>'int',//商品类型:1备库,2非库存,3咨询商品,4报备商品
        'order_source'       =>'tinyint',//订单来源:0备库,1直接下单,2咨询,3项目,4平台,5有赞,6售后补换货,7报备转单,8支付渠道,9采销录单,10结算补录
        'good_type'       =>'int',//商品类型 1正常2赠品3样品
        'addtime'       =>'datetime',//
        'updatetime'       =>'datetime',//
        'good_createrid'       =>'int',//商品创建人id
        'good_creater'       =>'varchar',//商品创建人
        'from_tag'       =>'tinyint',//来源标签：1采销(默认),2供应商端
        'supplier_origin_price'       =>'decimal',//供应商采购成本
        'cgd_supplier_code'       =>'varchar',//采购供应商编号
        'cgd_supplier_name'       =>'varchar',//采购供应商名称
        'cgd_apply_id'       =>'int',//竞单人
        'cgd_apply_name'       =>'varchar',//竞单人
    ];
    protected $createTime = 'addtime';
    protected $updateTime = 'updatetime';
}