<?php
namespace app\admin\model;

class Sale extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'bigint',//
        'orderCode'       =>'varchar',//销售单code
        'apply_id'       =>'bigint',//申请人id
        'apply_name'       =>'varchar',//申请人名称
        'order_type'       =>'int',//商品类型:1备库,2非库存,3咨询商品,4报备商品
        'order_source'       =>'tinyint',//订单来源:1直接下单,2咨询,3项目,4平台,5有赞,6售后补换货,7报备转单,8支付渠道9采销录单10结算录单
        'platform_id'       =>'bigint',//下单平台id
        'good_code'       =>'varchar',//商品code
        'skuCode'       =>'varchar',//
        'cat_id'       =>'int',//分类
        'good_name'       =>'varchar',//商品名称
        'good_num'       =>'int',//商品数量
        'good_type'       =>'int',//商品类型 1 正常商品2赠品3样品
        'origin_price'       =>'decimal',//成本价
        'sale_price'       =>'decimal',//销售价
        'total_price'       =>'decimal',//总价
        'post_fee'       =>'decimal',//总物流费
        'is_diff'       =>'tinyint',//是否有工差
        'is_activity'       =>'tinyint',//是否参与活动
        'activity_code'       =>'varchar',//活动编码
        'is_stock'       =>'tinyint',//是否库存
        'arrive_time'       =>'varchar',//到货时间
        'customer_code'       =>'varchar',//客户code
        'customerName'       =>'varchar',//客户名称
        'supplierNo'       =>'varchar',//公司供应商编号(实际存的是业务公司)
        'supplierName'       =>'varchar',//公司供应商名称(实际存的是业务公司)
        'supNo'       =>'varchar',//商品供应商编号
        'supName'       =>'varchar',//商品供应商名称
        'zxNo'       =>'varchar',//咨询单号
        'platform_order'       =>'varchar',//
        'send_num'       =>'int',//已发数量
        'wsend_num'       =>'int',//未发数量
        'th_num'       =>'int',//退货数量
        'th_fee'       =>'decimal',//退货金额
        'send_status'       =>'int',//发货状态 1未发货2部分发货3发货已完成
        'send_type'       =>'int',//发货类型 1直接发货2延时发货
        'remark'       =>'varchar',//
        'status'       =>'int',//订单状态 0待发货,1待发货完成,2发货已完成,3订单已取消
        'is_del'       =>'int',//是否删除
        'pay_id'       =>'int',//支付通道
        'proof_id'       =>'int',//凭证id
        'other_orderNo'       =>'varchar',//外部平台编号
        'paytime'       =>'varchar',//承诺回款时间
        'workNo'       =>'varchar',//业管单号
        'poNo'       =>'varchar',//po编号
        'use_order'       =>'int',//订单用途
        'good_weight'       =>'decimal',//商品总重
        'gold_price'       =>'decimal',//当日金价
        'cost_price'       =>'decimal',//工艺费
        'diff_weight'       =>'decimal',//工差重量
        'diff_fee'       =>'decimal',//工差费用
        'returnCode'       =>'varchar',//售后单号，售后生成的销售单才会有这个字段
        'addtime'       =>'datetime',//
        'updatetime'       =>'datetime',//
        'cgderid'       =>'int',//采购员id
        'cgder'       =>'varchar',//采购员(采购单对应的供应商负责人)
        'good_createrid'       =>'int',//商品创建人id
        'good_creater'       =>'varchar',//商品创建人
        'manager'       =>'varchar',//
        'managerid'       =>'int',//
    ];
    protected $createTime = 'addtime';
    protected $updateTime = 'updatetime';
}