<?php
namespace app\bug\model;

class AdminMenu extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'bigint',//
        'menu_name'       =>'varchar',//菜单名称
        'menu_code'       =>'varchar',//菜单code
        'menu_img'       =>'varchar',//菜单图片
        'menu_route'       =>'varchar',//菜单路由
        'menu_url'       =>'varchar',//菜单地址
        'pid'       =>'bigint',//父级id
        'is_show'       =>'int',//是否禁用
        'is_private'       =>'int',//是否私有
        'is_display'       =>'int',//是否展示
        'weight'       =>'double',//权重
        'status'       =>'int',//状态
        'is_del'       =>'int',//是否删除
        'addtime'       =>'datetime',//
        'updatetime'       =>'datetime',//

    ];
    protected $updateTime='updatetime';
    protected $createTime='addtime';
    public $status_cn=["禁用","启用"];
    
    public function GetMenuTree($pid=0){
        $Menu = $this->where(['pid'=>$pid,'is_del'=>0])
        ->field(['id','menu_name','menu_img','menu_route','menu_url','pid','is_private','is_display','weight','status'])
        ->order('weight desc,id asc')->select();
        if($Menu->isEmpty()){
        	return[];
        }
        foreach ($Menu as &$item){
        	$item['child']=$this->GetMenuTree($item->id);
        	if($pid>0){
        		$item['action']= Action::with(["actionInfo"])->where(["menuid"=>$item->id])->select();
        	}
        }
        return $Menu;
    }
}