<?php
namespace app\bug\model;

class Note extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'int',//
        'bugNo'       =>'varchar',//编号
        'noteNo'       =>'varchar',//编号
        'title'       =>'varchar',//问题标题
        'company_type'       =>'varchar',//公司平台类别
        'apply_name'       =>'varchar',//创建人
        'apply_id'       =>'int',//创建人id
        'model_id'       =>'text',//模块分类id
        'level'       =>'int',//优先级
        'type'       =>'int',//问题类型
        'weight'       =>'int',//权重
        'remark'       =>'text',//描述
        'submit'       =>'int',//处理人提交0取消1提交
        'status'       =>'int',//处理状态
        'is_del'       =>'int',//是否删除
        'addtime'       =>'datetime',//添加时间
        'updatetime'       =>'datetime',//更新时间

    ];
    protected $createTime="addtime";
    protected $updateTime="updatetime";
    public static $statusCn=["待分配","进行中","待测试","测试中","已拒绝","已关闭","延后处理","未关闭"];
    public static $typeCn=["缺陷(Bug)","任务(Task)","需求(Story)"];


    public static function onAfterWrite($model){
        $change= ["title","level","status","remark","noteNo","type","model_id"];
        $noteLog = new NoteLog();
        $origin = $model->getOrigin();
        $add=$model->getChangedData();
        $logAdd=[];
        foreach ($change as $key=>$value){
            $temp=[ 'bugNo'       =>$model->bugNo,//编号
                    'type'       =>isset($origin['id'])?2:1,//操作类型
                    'action_uid'       =>$model->updaterid,//操作人id
                    'action_name'       =>$model->updater,//操作人名称
                    'handle_name'       =>$value,//操作字段
                    'action_item'       =>empty($add)?"": $origin[$value]??"",//操作前值
                    'action_after'       =>empty($add)? $origin[$value]??'' :$add[$value]??"",//操作后值
                    ];
            if(empty($add)){
                $logAdd[]=$temp;
            }else{
               if(isset($add[$value])){
                   $logAdd[]=$temp;
               }
            }
        }
        if(!empty($logAdd)){
            $noteLog->saveAll($logAdd);
        }
    }
}