<?php
namespace app\bug\model;

use app\user\model\Headquarters;
use think\model\concern\SoftDelete;
class WorkRole extends Base
{
	use SoftDelete;
    protected $schema = [
        'id'       =>'int',//
        'role_name'       =>'varchar',//角色名称
        'level'       =>'tinyint',//角色名称
        'companyNo'       =>'varchar',//归属业务公司
        'work_id'       =>'int',//采购的功能模板
        'belong'       =>'tinyint',//系统归属1采销2结算3数据统计
        'belong_role_id'       =>'int',//系统归属角色id
        'action'       =>'text',//权限集合
        'process'       =>'text',//流程节点
        'status'       =>'tinyint',//状态
        'apply_id'       =>'int',//
        'apply_name'       =>'varchar',//创建人
        'createTime'       =>'datetime',//
        'updateTime'       =>'datetime',//
        'delete_time'       =>'datetime',//
];
    protected $updateTime='updateTime';
    protected $createTime='createTime';
    protected $deleteTime = 'delete_time';
    
    public function companyInfo(){
    	return $this->belongsTo(Headquarters::class,"companyNo","code")->bind(["companyName"=>"name"]);
    }
    
    public function WorkInfo(){
    	return $this->belongsTo(Work::class,"work_id","id")->bind(["work_name"]);
    }
    
    public function GetActionAttr($v){
    	return json_decode($v,true);
    }
    public function SetActionAttr($v){
        	return json_encode($v,JSON_UNESCAPED_UNICODE);
    }
    
    public function GetProcessAttr($v){
        	return json_decode($v,true);
        }
    public function SetProcessAttr($v){
            	return json_encode($v,JSON_UNESCAPED_UNICODE);
     }
}