<?php
namespace app\cxinv\model;

class InvoiceInterface extends Base
{
//设置字段信息
    protected $schema = [
        'id'  =>'bigint',//
        'invNo'  =>'varchar',//发票编号
        'KPFS'  =>'varchar',//0 开票方式 0 自动 1手动
        'KPLX'  =>'varchar',//开票类型0 蓝字发票 1 红字发票
        'XHFSBH'  =>'varchar',//企业纳税人识别号
        'XHFMC'  =>'varchar',//销货方对应的名称
        'XHFDZ'  =>'varchar',//销货方对应的地址
        'XHFDH'  =>'varchar',//销货方对应的电话
        'XHFYH'  =>'varchar',//销货方对应的开户行银行名称
        'XHFZH'  =>'varchar',//销货方对应的开户行银行账号
        'GMFBM'  =>'varchar',//购 买 方编 码 ,非 必 填
        'GMFSBH'  =>'varchar',//购买方识别号
        'GMFMC'  =>'varchar',//购货方名称，即发票抬头
        'GMFDZ'  =>'varchar',//购买方地址信息
        'GMFDH'  =>'varchar',//购买方电话
        'GMFYH'  =>'varchar',//购买方对应的开户行银行
        'GMFZH'  =>'varchar',//购买方对应的开户行账号,
        'GMFLX'  =>'varchar',//01 企业，02 机关事业单位，03 个人， 04 其他
        'GMFSJH'  =>'varchar',//购买方手 机
        'GMFDZYX'  =>'varchar',//X 购买方邮 箱
        'KPR'  =>'varchar',//开票人
        'SKR'  =>'varchar',//收款人
        'FHR'  =>'varchar',//复核人
        'YFPDM'  =>'varchar',//原发票代 码
        'YFPHM'  =>'varchar',//原发票号 码
        'YFPLX'  =>'varchar',//原发票类 型
        'YFPKPRQ'  =>'varchar',//原发票开 票日期
        'CHYY'  =>'varchar',//冲红原因 冲红原因, 冲红原因示例： 1-销货退回 2-开票有误 3-服务中止 4-销售折让
        'QDBZ'  =>'varchar',//0-普通发票;1-普通发票(清单); 2-收购发票;3-收购发票(清单); 4-成品油发票 5-机动车专票 6-机动车专票(清单) 0或2时系统根据项目名称字数,自动产 生清单 1或3时,系统取清单对应票面内容字段 打印到发票票面上，将项目信息 XMXX 打印到清单上。 默认为 0。 28 JSHJ 价税合计 20 string 是 小数点后 2 位
        'JSHJ'  =>'varchar',//小数点后 2 位，以元为单位精确到分； 不能为 0
        'HJJE'  =>'varchar',//小数点后 2 位，以元为单位精确到分。 可填写 0，由发票系统做价税分离，重 新赋值。
        'HJSE'  =>'varchar',//合计税额
        'BZ'  =>'varchar',//备注
        'TSCHBZ'  =>'varchar',//特殊冲红 标志当开票类型字段为 1(红字发票)时,该 字段必填:0 正常冲红(发票在发票系统 存在的数据可以正常冲红) 1 特殊冲红(发票在发票系统不存在的 数据需要特殊冲红)
        'DDMXXX'  =>'text',//(发票明细)(多条):商品明细不可传成品油和非成品油混合项目
        'FPLXDM'  =>'varchar',//发票类型代码
        'DDQQPCH'  =>'varchar',//订单请求 批次号
        'DDQQLSH'  =>'varchar',//订单请求 流水号
        'status'  =>'tinyint',//0 待发送数据 1开票中 2 开票成功 3 数据有误 4 开票失败
        'remark'  =>'varchar',//
        'result'  =>'text',//查询返回的结果集
        'is_check'  =>'tinyint',//0/1 是否获取开票结果
        'addtime'  =>'datetime',//
        'updatetime'  =>'datetime',//
       ];
}