<?php
namespace app\cxinv\model;

class TradeReturn extends Base
{
//设置字段信息
    protected $schema = [
        'id'  =>'bigint',//
        'returnCode'  =>'varchar',//退款编号
        'logNo'  =>'varchar',//资金认领编号
        'tradNo'  =>'varchar',//资金编号
        'companyNo'  =>'varchar',//业务公司
        'type'  =>'tinyint',//退款类型 1 退回认领资金 2 退款
        'apply_id'  =>'int',//申请id
        'apply_name'  =>'varchar',//申请人名称
        'return_reason'  =>'varchar',//退款原因
        'remark'  =>'varchar',//备注
        'return_img'  =>'longtext',//退款截图凭证(最多10张图片)
        'status'  =>'tinyint',//审核状态
        'is_del'  =>'tinyint',//是否删除
        'addtime'  =>'datetime',//
        'updatetime'  =>'datetime',//
       ];
    protected $createTime = 'addtime';
    protected $updateTime = 'updatetime';
    public function Trade(){
         return $this->belongsTo(Trade::class,'tradNo','tradNo')
        ->bind(['trade_out','trade_in','trade_bank','companyName','companyNo','customerName','customerNo','total_fee','balance','used_fee','poCode','NdCode']);
    }

    public function Pool(){
        return $this->belongsTo(TradePool::class,'logNo','logNo');
    }

}