<?php


namespace app\user\controller;


use app\user\model\Account;use app\user\model\AccountPlat;use think\App;use think\facade\Validate;
class Login extends Base{
	protected $noLogin=["loginIn"];
	public function __construct(App $app) {
		parent::__construct($app);
		$this->model=new Account();
	}

	public function loginIn(){
		$param =$this->request->param(["username"=>"","password"=>"","captcha"=>[]],"post","trim");
		$valid= Validate::rule([
			"username|账户"=>"require",
			"password|密码"=>"require|min:6|max:200",
			"captcha|验证码"=>"array"
			]);
		if($valid->check($param)==false)return error($valid->getError());
		$info = $this->model->with(['accountItem'=>['itemName'],"company_relaton",'userInfo'])->where
		(["username"=>$param['username'],"is_del"=>0])->findOrEmpty();
		  $info->hidden(['userInfo','password','salt','accountItem','openId']);
		if($info->isEmpty()) return error("账户不存在");
		$sha1 = sha1($param['password'] .$info->salt);
		if ($sha1 != $info->password) return error("密码错误");
		if ($info->status==0) return error("账户已禁用");
		$info->system_version = (new AccountPlat())->where(['account_id'=>$info->id])->column('system_version','plat_code');
		$token = makeToken($info->username);
		\app\common\User::instance()->LoginUserInfo($info->toArray(),$token,$this->keepTime);
		$info->token= $token;
		return success("登录成功",$info);
	}
}