<?php
namespace app\user\model;

class Account extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'bigint',//
        'username'       =>'varchar',//
        'password'       =>'varchar',//
        'salt'       =>'varchar',//
        'status'       =>'int',//
        'mobile'       =>'varchar',//
        'level'       =>'tinyint',//账户等级:1超管,2业务公司专用,3供应商专用
        'is_pass'       =>'int',//
        'is_del'       =>'int',//
        'source'       =>'varchar',//
        'addtime'       =>'datetime',//
        'updatetime'       =>'datetime',//

    ];
	protected $updateTime='updatetime';
    protected $createTime='addtime';
    public function userInfo(){
    	return $this->belongsTo(User::class,"id","account_id")->bind(["nickname","user_mobile"=>"mobile","openId","field_deny"]);
    }
    
    public function companyRelaton(){
    	return $this->hasMany(AccountCompany::class,'account_id')->where(["is_del"=>0]);
    }
    
    public function accountItem(){
    	return $this->belongsTo(AccountItem::class,'id',"account_id")->bind(["depart_name","itemid","depart_link","position"]);
    }
    
    public function changeAccount($id,$info=[]){
    	$account = $this->findOrEmpty($id);
        if(empty($info)) return;
        if(key_exists("mobile",$info)){
            $account->username=$info['mobile'];
            $account->mobile=$info['mobile'];
            $account->userInfo->mobile=$info['mobile'];
        }
        if(key_exists('nickname',$info)){
            $account->userInfo->nickname=$info['nickname'];
        }
        if(key_exists('email',$info)){
            $account->userInfo->email=$info['email'];
        }
          $account->save();
          $account->userInfo->save();
    }
}