<?php


namespace app\youzan\controller;


use app\common\facade\Youzan;
use app\youzan\model\Promocode;use think\App;use think\facade\Cache;

class Voucher extends Base{
    protected $activity_type = [7=>'优惠券',9=>'共享码',10=>'唯一码',11=>'社区团购券'];
    protected $activity_status_cn = [0=>'有效',1=>'无效',2=>'审核中'];
    public function __construct(App $app) {
        parent::__construct($app);
    }
    public function list(){
        $params = $this->request->param([
            	'activity_types'=>[10],
            	'page'=>1,
            	'status'=>0,
            	'size'=>10
        	]);
        if(!empty($params['activity_types'])) $where[] = ["activity_type",'in',$params['activity_types']];
        if($params['status']!=0) $where[] = $params['status']==3?["status","in",[0,2]]:['status','=',$params['status']];
        $list = Promocode::where($where)->order("id desc")->paginate(["list_rows"=>$params['size'],"page"=>$params['page']])
        ->each(function ($item){
            $item['activity_type_cn'] = $this->activity_type[$item['activity_type']];
            $item['status_cn'] = $this->activity_status_cn[$item['status']];
        });
        return success('SUCCESS',['list'=>$list->items(),'total'=>$list->total()]);
    }

    public function delete(){
        $params = $this->request->param([
            'activity_id'=>'',
        ]);
        if($params['activity_id']==''){
            return error('参数错误');
        }
        $params['activity_id'] = intval($params['activity_id']);
        $params['operator_type']=0;
        $params['operator_id']=0;
        $params['app_name']='youzanyun';
        $data = Youzan::getData('promocode_delete',$params);
        if($data['code']!='200') return error($data['message']);
        return success($data['message']);
    }

    public function refesh(){
        $params = $this->request->param([
                       'activity_type_group' => 2,
                                       'time_line_status' => 0,
                                       'page_num' => 1,
                                       'page_size' => 20
                	]);
        $bool = Cache::get("voucher_list_params");
        if($bool) return error('一小时内只能刷新一次');
        Cache::set('voucher_list_params',$params,3600);
        event('voucher',$params);
        return success('稍后刷新页面');
    }
}