<?php
namespace app\youzan\model;

class Good extends Base
{
//设置字段信息
    protected $schema = [
        'id'  =>'bigint',//
        'item_no'  =>'varchar',//商品自定义编码 skuCode
        'image_ids'  =>'varchar',//图片集合列表
        'item_type'  =>'tinyint',// 0—普通商品 3—UMP降价拍 5—外卖商品 10—分销商品 20—会员卡商品 21—礼品卡商品 22—团购券 25—批发商品 30—收银台商品 31—知识付费商品 35—酒店商品 40—美业商品 60—虚拟商品 61—电子卡券
        'summary'  =>'varchar',//分享描述，微信分享给好友时会显示，建议36个字以内，最多不能超出100个字
        'brand_id'  =>'int',//商品品牌id，连锁L-专业版店铺发布商品到网店或门店时使用
        'title'  =>'varchar',//商品标题。不能超过100字，受违禁词控制
        'support_refund'  =>'tinyint',//是否支持退款。1：支持；0：不支持。仅对虚拟商品、电子卡券有效
        'is_support_barter'  =>'tinyint',//商品是否支持换货：0. 不支持，1. 支持。仅支持实物商品，其他商品类型忽略
        'desc'  =>'text',//商品描述
        'item_weight'  =>'decimal',//商品重量，单位：克
        'category_id'  =>'int',//分类id
        'auto_listing_time'  =>'varchar',//开始出售时间，默认为0，0—立即出售，传值表示定时开售时间，注意：定时开售时间一定要大于当前时间，Unix时间戳，单位：毫秒。当is_display=0时，定时开售时间设置不生效。
        'buy_btn_label'  =>'varchar',//自定义立即购买按钮文案，支持6个字以内。当buy_btn_config=1时，该字段必传
        'start_sale_num'  =>'int',//商品起售数,默认为1，起售数量超出商品库存时，买家无法购买该商品
        'buy_btn_config'  =>'tinyint',//商详立即购买按钮 : 立即购买按钮配置 0.默认 1.自定义
        'stock_deduct_mode'  =>'tinyint',//库存扣减方式,0：拍下减库存，买家提交订单，扣减库存数量。1-付款减库存，买家支付成功，扣减库存数量.不传默认拍下减库存
        'join_level_discount'  =>'tinyint',//是否参加会员折扣：1-支持，0-不支持，默认不支持
        'is_display'  =>'tinyint',//是否上架商品，1—上架商品，0—不上架商品(管理端显示为仓库中)，新增若不传该字段默认传1
        'quantity'  =>'int',//库存数 无sku情况下库存必填，如果有sku则无效
        'hide_stock'  =>'tinyint',//是否隐藏商品库存，在商品展示时不显示商品的库存，0-显示库存，1-不显示库存，默认0
        'sell_point'  =>'text',//商品卖点信息
        'tag_ids'  =>'varchar',//商品有赞分组
        'item_id'  =>'varchar',//商品id
        'sku_id'  =>'varchar',//规格id(有赞平台)
        'detail_url'  =>'varchar',//有赞详情页面
        'alias'  =>'varchar',//商品别名
        'status'  =>'tinyint',//商品状态,6上线成功,8已下线
        'origin'  =>'decimal',//商品划线价
        'price'  =>'decimal',//商品价(最后售价)
        'cost_price'  =>'decimal',//商品成本价
        'post_fee'  =>'decimal',//运费
        'is_del'  =>'tinyint',//是否删除,0未删除,1删除
        'admin_name'  =>'varchar',//创建人
        'distribution'  =>'varchar',//1快递2同城3自提
        'admin_id'  =>'int',//创建人id
        'action_id'  =>'int',//操作人id
        'action_name'  =>'varchar',//操作人
        'addtime'  =>'datetime',//新建时间
        'updatetime'  =>'datetime',//更新时间
       ];
}