<?php
namespace app\youzan\model;

class Order extends Base
{
//设置字段信息
    protected $schema = [
        'id'  =>'bigint',//
        'tid'  =>'varchar',//有赞订单id
        'kdt_id'  =>'varchar',//有赞店铺id
        'data'  =>'text',//订单内容
        'trade_memo'  =>'varchar',//卖家备注
        'buyer_message'  =>'varchar',//买家留言
        'taxpayer_id'  =>'varchar',//买家税号
        'user_name'  =>'varchar',//抬头
        'invoice_detail_type'  =>'varchar',//发票详情类型:itemCategory 商品类别,itemDetail 商品明细
        'email'  =>'varchar',//买家邮箱
        'express_state'  =>'varchar',//物流状态 0:待发货; 1:已发货
        'express_type'  =>'varchar',//发货方式。 0:手动发货（商城后台人工发货），1:接口发货（有赞云发货API发货）
        'order_discount_fee'  =>'decimal',//订单级优惠总金额，单位：元
        'item_discount_fee'  =>'decimal',//商品级优惠总金额，单位：元
        'adjust_fee'  =>'decimal',//订单改价金额，单位：元。带“-”负数表示涨价金额，不带“-”表示减价金额。例如：返回值：-0.01-表示涨价0.01元，0.01-表示减价0.01元。
        'refund_fee'  =>'decimal',//退款金额，单位：元
        'status'  =>'varchar',//主订单状态： WAIT_BUYER_PAY：等待买家付款，定金预售描述：定金待付、等待尾款支付开始、尾款待付， TRADE_PAID：订单已支付 ，该状态仅代表当前订单已支付成功，表示瞬时状态，稍后会自动修改成后面的状态。如果不关心此状态请再次请求详情接口获取下一个状态， WAIT_CONFIRM：待确认，包含待成团、待接单等等。即：买家已付款，等待成团或等待接单， WAIT_SELLER_SEND_GOODS：等待卖家发货，即：买家已付款， WAIT_BUYER_CONFIRM_GOODS 等待买家确认收货，即：卖家已发货， TRADE_SUCCESS：买家已签收以及订单成功， TRADE
        'addtime'  =>'datetime',//订单新建时间
        'updatetime'  =>'datetime',//修改时间
       ];
}