<?php
namespace app\youzan\model;

class OrderInfo extends Base
{
//设置字段信息
    protected $schema = [
        'id'  =>'bigint',//
        'tid'  =>'varchar',//有赞订单id
        'oid'  =>'varchar',//订单明细id 子订单id
        'item_id'  =>'varchar',//有赞商品id
        'tax_total'  =>'decimal',//税费
        'is_pre_sale'  =>'tinyint',//是否预售 1是 0否
        'goods_cost_price'  =>'decimal',//成本价
        'buyer_messages'  =>'varchar',//买家留言
        'price'  =>'decimal',//单商品原价，单位：元
        'title'  =>'varchar',//商品名称
        'sku_no'  =>'varchar',//规格编码
        'item_no'  =>'varchar',//商品编码
        'tariff_rule'  =>'tinyint',//税费模式"1":含税模式、"0":税费分离(貌似没有这个字段)
        'payment'  =>'decimal',//订单明细应付金额订单上每个商品最终均摊价，单位：元
        'is_present'  =>'tinyint',//是否赠品，是：true，否：false
        'item_type'  =>'tinyint',//商品类型，0:普通商品; 1:拍卖商品; 5:餐饮商品; 10:分销商品; 20:会员卡商品; 21:礼品卡商品; 23:有赞会议商品; 24:周期购; 30:收银台商品; 31:知识付费商品; 35:酒店商品; 40:普通服务类商品; 71:卡项商品;182:普通虚拟商品; 183:电子卡券商品; 201:外部会员卡商品; 202:外部直接收款商品; 203:外部普通商品; 204:外部服务商品;205:mock不存在商品; 206:小程序二维码;207:积分充值商品;208:付费优惠券商品
        'outer_item_id'  =>'varchar',//商品编码，商家自定义编码，可用于和其他系统之间商品的外部id的标识。零售店铺类型返回的是商品的条码信息
        'outer_sku_id'  =>'varchar',//微商城店铺类型：outer_sku_id 对应的是规格编码；在零售店铺类型场景下outer_sku_id 对应的是规格条码；商品规格编码，sku_id值不为0时：返回商品规格编码；sku_id值为0时：当设置商品编码后且开启多网点功能，返回值为商品编码，否则返回空。
        'total_fee'  =>'decimal',//商品总价（扣除商品级优惠） 单位：元
        'sku_id'  =>'varchar',//商品规格id，有赞生成的规格id。无规格商品返回0
        'sku_unique_code'  =>'varchar',//商品唯一编码
        'num'  =>'int',//商品数量
        'is_price_calendar'  =>'tinyint',//是否为价格日历商品，是：返回为1，否返回为空
        'pic_path'  =>'varchar',//商品图片
        'pre_sale_type'  =>'tinyint',//0 全款预售，1 定金预售
        'alias'  =>'varchar',//商品别名
        'discount_price'  =>'decimal',//单商品现价，减去了商品的优惠金额。单位：元
        'points_price'  =>'decimal',//商品积分价（非积分商品则为0），如返回值是100则表示100积分。
        'sku_properties_name'  =>'text',//商品规格信息（无规格商品为空）
        'weight'  =>'decimal',//商品重量 单位是 g
        'refund_fee'  =>'decimal',//退款金额
        'yz_open_id'  =>'varchar',//买家在有赞的唯一id
        'status'  =>'tinyint',//状态 0(财务通过)待处理1处理中,2待产品审核,3产品驳回,4待财务审核,5财务驳回,6成功转单,7订单取消,8系统转单失败
        'fee_type'  =>'tinyint',//费用类型
        'reason'  =>'varchar',//失败原因或者驳回原因
        'orderCode'  =>'varchar',//销售订单编号(对应于采销系统中的sale表)
        'is_approved'  =>'tinyint',//是否审核通过，0未通过，1通过
        'updateid'  =>'int',//更新人id
        'updater'  =>'varchar',//更新人
        'addtime'  =>'datetime',//创建时间
        'updatetime'  =>'datetime',//更新时间
        'is_del'  =>'tinyint',//删除删除，0未删除，1已删除
       ];
}