<?php

return [
    // 默认使用的数据库连接配置
    'default'         => env('database.driver', 'mysql'),

    // 自定义时间查询规则
    'time_query_rule' => [],

    // 自动写入时间戳字段
    // true为自动识别类型 false关闭
    // 字符串则明确指定时间字段类型 支持 int timestamp datetime date
    'auto_timestamp'  => true,

    // 时间字段取出后的默认时间格式
    'datetime_format' => 'Y-m-d H:i:s',

    // 时间字段配置 配置格式：create_time,update_time
    'datetime_field'  => '',

    // 数据库连接配置信息
    'connections'     => [
//    	采销数据库
        'mysql' => [
            // 数据库类型
            'type'            => env('database.type', 'mysql'),
            // 服务器地址
            'hostname'        => env('database.hostname', '127.0.0.1'),
            // 数据库名
            'database'        => env('database.database', ''),
            // 用户名
            'username'        => env('database.username', 'root'),
            // 密码
            'password'        => env('database.password', ''),
            // 端口
            'hostport'        => env('database.hostport', '3306'),
            // 数据库连接参数
            'params'          => [],
            // 数据库编码默认采用utf8
            'charset'         => env('database.charset', 'utf8'),
            // 数据库表前缀
            'prefix'          => env('database.prefix', ''),

            // 数据库部署方式:0 集中式(单一服务器),1 分布式(主从服务器)
            'deploy'          => 0,
            // 数据库读写是否分离 主从式有效
            'rw_separate'     => false,
            // 读写分离后 主服务器数量
            'master_num'      => 1,
            // 指定从服务器序号
            'slave_no'        => '',
            // 是否严格检查字段是否存在
            'fields_strict'   => true,
            // 是否需要断线重连
            'break_reconnect' => false,
            // 监听SQL
            'trigger_sql'     => env('app_debug', true),
            // 开启字段缓存
            'fields_cache'    => false,
        ],
        //账户数据库
		'mysql_account' => [
            // 数据库类型
            'type'            => env('mysql_sys.type', 'mysql'),
            // 服务器地址
            'hostname'        => env('mysql_sys.hostname', '127.0.0.1'),
            // 数据库名
            'database'        => env('mysql_sys.database', ''),
            // 用户名
            'username'        => env('mysql_sys.username', 'root'),
            // 密码
            'password'        => env('mysql_sys.password', ''),
            // 端口
            'hostport'        => env('mysql_sys.hostport', '3306'),
            // 数据库连接参数
            'params'          => [],
            // 数据库编码默认采用utf8
            'charset'         => env('mysql_sys.charset', 'utf8'),
            // 数据库表前缀
            'prefix'          => env('mysql_sys.prefix', ''),

            // 数据库部署方式:0 集中式(单一服务器),1 分布式(主从服务器)
            'deploy'          => 0,
            // 数据库读写是否分离 主从式有效
            'rw_separate'     => false,
            // 读写分离后 主服务器数量
            'master_num'      => 1,
            // 指定从服务器序号
            'slave_no'        => '',
            // 是否严格检查字段是否存在
            'fields_strict'   => true,
            // 是否需要断线重连
            'break_reconnect' => false,
            // 监听SQL
            'trigger_sql'     => env('app_debug', true),
            // 开启字段缓存
            'fields_cache'    => false,
        ],
        
        //结算数据库
		'mysql_cxinv' => [
            // 数据库类型
            'type'            => env('mysql_cxinv.type', 'mysql'),
            // 服务器地址
            'hostname'        => env('mysql_cxinv.hostname', '127.0.0.1'),
            // 数据库名
            'database'        => env('mysql_cxinv.database', ''),
            // 用户名
            'username'        => env('mysql_cxinv.username', 'root'),
            // 密码
            'password'        => env('mysql_cxinv.password', ''),
            // 端口
            'hostport'        => env('mysql_cxinv.hostport', '3306'),
            // 数据库连接参数
            'params'          => [],
            // 数据库编码默认采用utf8
            'charset'         => env('mysql_cxinv.charset', 'utf8'),
            // 数据库表前缀
            'prefix'          => env('mysql_cxinv.prefix', ''),

            // 数据库部署方式:0 集中式(单一服务器),1 分布式(主从服务器)
            'deploy'          => 0,
            // 数据库读写是否分离 主从式有效
            'rw_separate'     => false,
            // 读写分离后 主服务器数量
            'master_num'      => 1,
            // 指定从服务器序号
            'slave_no'        => '',
            // 是否严格检查字段是否存在
            'fields_strict'   => true,
            // 是否需要断线重连
            'break_reconnect' => false,
            // 监听SQL
            'trigger_sql'     => env('app_debug', true),
            // 开启字段缓存
            'fields_cache'    => false,
        ],
        
        //有赞数据库
       'mysql_yz' => [
                    // 数据库类型
                    'type'            => env('mysql_yz.type', 'mysql'),
                    // 服务器地址
                    'hostname'        => env('mysql_yz.hostname', '127.0.0.1'),
                    // 数据库名
                    'database'        => env('mysql_yz.database', ''),
                    // 用户名
                    'username'        => env('mysql_yz.username', 'root'),
                    // 密码
                    'password'        => env('mysql_yz.password', ''),
                    // 端口
                    'hostport'        => env('mysql_yz.hostport', '3306'),
                    // 数据库连接参数
                    'params'          => [],
                    // 数据库编码默认采用utf8
                    'charset'         => env('mysql_yz.charset', 'utf8'),
                    // 数据库表前缀
                    'prefix'          => env('mysql_yz.prefix', ''),
        
                    // 数据库部署方式:0 集中式(单一服务器),1 分布式(主从服务器)
                    'deploy'          => 0,
                    // 数据库读写是否分离 主从式有效
                    'rw_separate'     => false,
                    // 读写分离后 主服务器数量
                    'master_num'      => 1,
                    // 指定从服务器序号
                    'slave_no'        => '',
                    // 是否严格检查字段是否存在
                    'fields_strict'   => true,
                    // 是否需要断线重连
                    'break_reconnect' => false,
                    // 监听SQL
                    'trigger_sql'     => env('app_debug', true),
                    // 开启字段缓存
                    'fields_cache'    => false,
                ],
                
                 //工单数据
       'mysql_bug' => [
                    // 数据库类型
                    'type'            => env('mysql_bug.type', 'mysql'),
                    // 服务器地址
                    'hostname'        => env('mysql_bug.hostname', '127.0.0.1'),
                    // 数据库名
                    'database'        => env('mysql_bug.database', ''),
                    // 用户名
                    'username'        => env('mysql_bug.username', 'root'),
                    // 密码
                    'password'        => env('mysql_bug.password', ''),
                    // 端口
                    'hostport'        => env('mysql_bug.hostport', '3306'),
                    // 数据库连接参数
                    'params'          => [],
                    // 数据库编码默认采用utf8
                    'charset'         => env('mysql_bug.charset', 'utf8'),
                    // 数据库表前缀
                    'prefix'          => env('mysql_bug.prefix', ''),
        
                    // 数据库部署方式:0 集中式(单一服务器),1 分布式(主从服务器)
                    'deploy'          => 0,
                    // 数据库读写是否分离 主从式有效
                    'rw_separate'     => false,
                    // 读写分离后 主服务器数量
                    'master_num'      => 1,
                    // 指定从服务器序号
                    'slave_no'        => '',
                    // 是否严格检查字段是否存在
                    'fields_strict'   => true,
                    // 是否需要断线重连
                    'break_reconnect' => false,
                    // 监听SQL
                    'trigger_sql'     => env('app_debug', true),
                    // 开启字段缓存
                    'fields_cache'    => false,
                ],
        // 更多的数据库配置信息
    ],
];
